package space.anyi.autoConnectNetwork;

import cn.afterturn.easypoi.excel.ExcelImportUtil;
import cn.afterturn.easypoi.excel.entity.ImportParams;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.openqa.selenium.By;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.firefox.FirefoxDriver;
import org.openqa.selenium.firefox.FirefoxOptions;
import space.anyi.autoConnectNetwork.entry.Student;

import java.io.*;
import java.net.HttpURLConnection;
import java.net.URL;
import java.nio.charset.StandardCharsets;
import java.time.LocalDateTime;
import java.time.ZoneId;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * @ProjectName: autoConnectNetwork
 * @FileName: Main
 * @Author: 杨逸
 * @Data:2024/5/28 8:38
 * @Description:
 */
public class Main {
    private static final ObjectMapper objectMapper = new ObjectMapper();
    public static void main(String[] args) throws IOException, InterruptedException {
        f2();
    }

    /**
     * 模拟点击的方式连接校园网
     * @param args
     * @throws IOException
     * @throws InterruptedException
     * @description:
     * @author: 杨逸
     * @data:2024/10/16 12:56:21
     * @since 1.0.0
     */
    public static void f1(String[] args) throws IOException, InterruptedException {
        if (args.length!=4) {
            System.out.println("参数错误");
            System.out.println("用户名,密码,firefoxDriver,firefoxPath未设置正确");
            return;
        }
        String username = args[0];
        String password = args[1];
        String gecko = args[2];
        String firefoxPath = args[3];
        System.setProperty("webdriver.gecko.driver",gecko);
        while (true){
            System.out.println("判断网络是否连接");
            System.out.println(LocalDateTime.now(ZoneId.systemDefault()));
            if (!connected()){
                // 执行连接操作
                System.out.println("执行连接操作");
                connection(username,password,firefoxPath);
            }
            // 每隔60秒检查一次
            Thread.sleep(1000*60);
        }
    }

    /**
     * 调接口连接校园网
     * @throws IOException
     * @throws InterruptedException
     * @description:
     * @author: 杨逸
     * @data:2024/10/16 13:18:22
     * @since 1.0.0
     */
    public static void f2() throws IOException, InterruptedException {
        //初始化校园网信息
        List<Student> list = new ArrayList<>();
        ImportParams importParams = new ImportParams();
        importParams.setTitleRows(1);
        importParams.setHeadRows(1);
        list = ExcelImportUtil.importExcel(new File("账号密码.xlsx"), Student.class, importParams);
        int mod = list.size(),index  = 0;

        while (true){
            //判断网络是否连接
            if (!connected()){
                System.out.println("=======================");
                System.out.println("无网络连接");
                System.out.println("index = " + index);
                //连接网络
                Student student = list.get(index);
                String userId = student.getSno().trim();
                if(userId.charAt(0) == '\'')userId = userId.substring(1);
                String password = student.getCardId().trim().substring(0,10);
                if(password.charAt(0) == '\'')password = student.getCardId().trim().substring(1,11);
                System.out.println("用户名:"+userId);
                System.out.println("密码:"+password);
                try {
                    //连接校园网
                    connection(userId,password);
                }catch (IOException e){
                    e.printStackTrace();
                    System.err.println("检查网络连接是否已经连接到校园网的WiFi");
                    break;
                }

                index++;
                index%=mod;
            }
            Thread.sleep(1000);
        }

    }

    private static void connection(String userId, String password) throws IOException {
        String queryString= "nasip%3Dcc5b64e516a1fa61d915e184b913e171";
        HttpURLConnection httpURLConnection = (HttpURLConnection) new URL("http://10.30.252.71/eportal/index.jsp?nasip=cc5b64e516a1fa61d915e184b913e171").openConnection();
        //打开首页获取cookie和session
        String cookie;
        {
            httpURLConnection.setRequestMethod("GET");
            httpURLConnection.connect();
            //print(httpURLConnection.getInputStream());
            System.out.println(httpURLConnection.getResponseCode());
            Map<String, List<String>> headerFields = httpURLConnection.getHeaderFields();
            cookie = headerFields.get("Set-Cookie").get(0);
            System.out.println("cookie = " + cookie);
            httpURLConnection.disconnect();
        }

        //登陆
        String userIndex = "";
        {
            //电信
            String service = "",passwordEncrypt = "false";
            service = "DianXin";
            httpURLConnection = (HttpURLConnection) new URL("http://10.30.252.71/eportal/InterFace.do?method=login").openConnection();
            httpURLConnection.setRequestMethod("POST");
            httpURLConnection.setRequestProperty("Cookie",cookie);
            httpURLConnection.setDoOutput(true);

            StringBuilder stringBuilder = new StringBuilder("").append("userId=").append(userId).append("&password=").append(password).append("&service=").append(service).append("&queryString=").append(queryString).append("&passwordEncrypt=").append(passwordEncrypt);
            OutputStream outputStream = httpURLConnection.getOutputStream();
            outputStream.write(stringBuilder.toString().getBytes(StandardCharsets.UTF_8));
            outputStream.flush();
            outputStream.close();

            httpURLConnection.connect();
            System.out.println(httpURLConnection.getResponseCode());
            String response = print(httpURLConnection.getInputStream());

            String s = response.split(":")[1].split(",")[0];
            userIndex = s.substring(1,s.length()-1);
            System.out.println(userIndex);
            httpURLConnection.disconnect();

            Map map = objectMapper.readValue(response, Map.class);
            String message = (String) map.get("message");
            //if ("false::PWD_REGULAR_MODIFY_WEB".equals(message)){
            //    System.out.println("重置密码");
            //    return true;
            //}
            //联通
            service = "LianTong";
            if (userIndex.length()<4){
                httpURLConnection = (HttpURLConnection) new URL("http://10.30.252.71/eportal/InterFace.do?method=login").openConnection();
                httpURLConnection.setRequestMethod("POST");
                httpURLConnection.setRequestProperty("Cookie",cookie);
                httpURLConnection.setDoOutput(true);

                stringBuilder = new StringBuilder("").append("userId=").append(userId).append("&password=").append(password).append("&service=").append(service).append("&queryString=").append(queryString).append("&passwordEncrypt=").append(passwordEncrypt);
                outputStream = httpURLConnection.getOutputStream();
                outputStream.write(stringBuilder.toString().getBytes(StandardCharsets.UTF_8));
                outputStream.flush();
                outputStream.close();

                httpURLConnection.connect();
                System.out.println(httpURLConnection.getResponseCode());
                response = print(httpURLConnection.getInputStream());
                s = response.split(":")[1].split(",")[0];
                userIndex = s.substring(1,s.length()-1);
                System.out.println(userIndex);
                httpURLConnection.disconnect();
                map = objectMapper.readValue(response, Map.class);
                message = (String) map.get("message");
                //if ("false::PWD_REGULAR_MODIFY_WEB".equals(message)){
                //    System.out.println("重置密码");
                //    return true;
                //}
            }
        }


        if (userIndex.length()<4)return ;
        //获取用户信息
        byte[] userIndexBytes = new String("userIndex=" + userIndex).getBytes();;
        {
            httpURLConnection = (HttpURLConnection) new URL("http://10.30.252.71/eportal/InterFace.do?method=getOnlineUserInfo").openConnection();
            httpURLConnection.setRequestMethod("POST");
            httpURLConnection.setRequestProperty("Cookie",cookie);
            httpURLConnection.setDoOutput(true);

            OutputStream outputStream = httpURLConnection.getOutputStream();
            outputStream.write(userIndexBytes);
            outputStream.flush();
            outputStream.close();

            httpURLConnection.connect();
            System.out.println(httpURLConnection.getResponseCode());
            print(httpURLConnection.getInputStream());
            httpURLConnection.disconnect();
        }

    }

    /**
     * 连接网络
     * @param username
     * @param password
     * @param firefoxPath
     * @throws InterruptedException
     * @description:
     * @author: 杨逸
     * @data:2024/10/16 12:56:45
     * @since 1.0.0
     */
    private static void connection(String username, String password,String firefoxPath) throws InterruptedException {
        FirefoxDriver firefoxDriver = null;
        try {
            System.out.println("注册驱动");
            firefoxDriver = fireFoxDriverInit(firefoxPath);
            //打开网页
            firefoxDriver.get("http://10.30.252.71/eportal/index.jsp?nasip=cc5b64e516a1fa61d915e184b913e171");
            //firefoxDriver.get("http://baidu.com");
            Thread.sleep(200);
            //模拟输入用户名和密码
            firefoxDriver.findElement(By.cssSelector("#username")).sendKeys(username);

            WebElement element = firefoxDriver.findElement(By.cssSelector("#pwd"));
            firefoxDriver.executeScript("arguments[0].value = " + password,element);
            //选择登陆模式
            firefoxDriver.findElement(By.cssSelector("#selectDisname")).click();
            firefoxDriver.findElement(By.cssSelector("#_service_2")).click();
            Thread.sleep(1000);
            //模拟点击登录
            firefoxDriver.findElement(By.cssSelector("#loginLink_div")).click();
        } finally {
            //释放资源
            if (firefoxDriver != null) {
                firefoxDriver.quit();
            }
            System.out.println("释放资源");
        }
    }

    private static FirefoxDriver fireFoxDriverInit(String fireFoxPath) {
        //创建一个浏览器配置对象
        FirefoxOptions options = new FirefoxOptions();

        //设置参数
        //开启无头模式
        options.addArguments("--headless");
        //设置窗口大小
        options.addArguments("--window-size=1920,1080");
        //设置允许所有远程连接
        //options.addArguments("--remote-allow-origins=*");
        //设置请求头
        options.addArguments("user-agent=Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/118.0.0.0 Safari/537.36");
        options.setBinary(fireFoxPath);

        return new FirefoxDriver(options);
    }

    /**
     * 判断是否联网
     * @return boolean
     * @throws IOException
     * @description:
     * @author: 杨逸
     * @data:2024/05/28 08:50:05
     * @since 1.0.0
     */
    private static boolean connected() throws IOException {
        return ping("bing.com",5) || ping("baidu.com",5);
    }

    /**
     * 判断是否能ping通
     * @param target_name 主机名
     * @param out_time 超时时间
     * @return boolean
     * @throws IOException
     * @description:
     * @author: 杨逸
     * @data:2024/05/28 08:49:12
     * @since 1.0.0
     */
    private static boolean ping(String target_name, int out_time) throws IOException {

        Runtime runtime = Runtime.getRuntime();

        String ping_command = "ping " + target_name + " -w " + out_time;

        //System.out.println("命令格式：" + ping_command);

        Process process = runtime.exec(ping_command);

        if (null == process)
            return false;

        BufferedReader bufferedReader = new BufferedReader(
                new InputStreamReader(process.getInputStream(), "GBK"));// windows下编码默认是GBK，Linux是UTF-8

        String line = null;

        while (null != (line = bufferedReader.readLine())) {

            //System.out.println(line);

            if (line.startsWith("bytes from",3))
                return true;
            if (line.startsWith("来自"))
                return true;
        }

        bufferedReader.close();

        return false;
    }

    /**
     * 打印输入流
     * @param inputStream
     * @return {@code String }
     * @throws IOException
     * @description:
     * @author: 杨逸
     * @data:2024/10/16 13:13:17
     * @since 1.0.0
     */
    private static String print(InputStream inputStream) throws IOException {
        BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(inputStream));
        StringBuilder stringBuilder = new StringBuilder();
        while (bufferedReader.ready()) {
            stringBuilder.append(bufferedReader.readLine());
        }
        System.out.println(stringBuilder.toString());
        bufferedReader.close();
        return stringBuilder.toString();
    }
}
